//*****************************************
// AT mega328 Two Nixie Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:ad_conv.c
//
//  2016/03/26 Taishi
//*****************************************
#include				<avr/io.h>

#include	"two_nixie.h"
#include	"ad_conv.h"

int				ad0_data[N_of_AD_data];
int				ad0_ave;
unsigned char	ad0_count;
// *******************************************************
// ************************* A/D 0 ***********************
// *******************************************************

//*****************************************
// A/D 0 Initial
// @荞ݕs̏ԂŌĂ΂Ƃ
//  PA0(ADC0): High Volt Monitor Max. about 0.55V (512 = 200V)
//*****************************************
void	ad0_init(void)
{
	unsigned char	i;

	ad0_count = 0;
	for(i = 0; i < N_of_AD_data; i++){
		ad0_data[i] = 0;
	}
	ad0_ave = 0;

	DDRC &= ~(1 << DDC0);																	// Port-C Bit0 : Input

	PRR &= ~( 1 << PRADC );																	// A/D ғ
	DIDR0 |= (1 << ADC0D);																	// AiO͐ݒ PD0

	ADMUX = ( (1 << REFS1) | (0 << REFS0) | (0 << MUX2) | (0 << MUX1) | (0 << MUX0) );		// PDPudgp, Select ADC0
	ADCSRA = ( (1 << ADEN) | (1 << ADSC) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0) );	// A/D, A/DϊJn, CK/128=8MHz/128=62.5kHz(16uS) --> 208uS

}
//*****************************************
// A/D 0 close
//*****************************************
void	ad0_close(void)
{
	ADCSRA = 0;																				// A/Ds
}
//*****************************************
// A/D 0 Set A/D data to Data Buffer
//  ϊIĂȂ́@Ȃ
//*****************************************
void	ad0_set_data(void)
{
	if( (ADCSRA & (1 << ADIF)) != 0){								// `^cϊ
		ADCSRA |= (1 << ADIF);										// `^cϊtO폜
		ad0_data[ad0_count] = ADCW;
		ad0_count++;
		ad0_count &= (N_of_AD_data - 1);

		ADCSRA |= (1 << ADSC);										// A/DϊJn
	}
}
//*****************************************
// A/D 0 Get A/D data
//  obt@ɓĂf[^𕽋ςĎ擾
//  擾f[^ ad0_ave ɓ
//*****************************************
void	ad0_get_data(void)
{
	unsigned char	i;
	unsigned int	sum;

	sum = 0;
	for(i = 0; i < N_of_AD_data; i++){						// obt@Sđ
		sum += ad0_data[i];
	}

	sum /= N_of_AD_data;									// f[^Ŋĕϒlɂ

	ad0_ave = sum;
}
