//*****************************************
// AT mega328 Two Nixie Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:two_nixie.c
//
//  2016/03/26 Taishi
//  2016/08/07 check()~߂
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"two_nixie.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"display.h"
#include	"ad_conv.h"
#include	"nixie.h"
#include	"rtc_ds3234.h"
#include	"set_rtc.h"

static	unsigned char	run=0;
static	unsigned char	dc_match=0;
static	int				bef1_ad0_ave=0;
static	unsigned char	renzoku[16]={1,6,2,7,5,0,4,9,8,3,15,15,15,15,15,15};
static	unsigned char	gyaku_renzoku[16]={3,8,9,4,0,5,7,2,6,1,15,15,15,15,15,15};
static	unsigned char	num_count=0;

// f[^o͑삷
void	output_data(void)
{
	if(run == 0){					// nee̎
		pulse_out = PULSE_OUT_MAX;
		run = 1;					// nm
	}else{							// nm̎
		run = 0;					// nee
	}
}
// `^c̒lłnmpXω
//  `^cl ad0_ave ɂ
//  pX pulse_out ɓ
void	feed_back_pro(void)
{
	int		p;
	int		nxt_ad0_ave;
	int		sa;

	p = pulse_out;
	sa = ad0_ave - bef1_ad0_ave;
	if(0 < sa){											// o̎
		nxt_ad0_ave = ad0_ave + sa + sa;				// \l傫
	}else{
		nxt_ad0_ave = ad0_ave + sa;
	}

	if (ad0_ave == LEVEL_AD){							// ڕWl̎
		;
	}else if (ad0_ave < LEVEL_AD){						// ܂Ⴂ
		if(LEVEL_AD_L <= ad0_ave){						// ڕWlɗƍl
			p += OUT_BAND;								// ۂ͉Ȃ
		}else if(LEVEL_AD_NL <= nxt_ad0_ave){			// ڕWlɖwǋ߂Âƍl
			p += OUT_NEAR;								// ω
		}else if(LEVEL_AD_ML <= nxt_ad0_ave){			// ڕWlɑ啪߂Âƍl
			p += OUT_MID;								// ω
		}else if(nxt_ad0_ave < LEVEL_AD_ML){			// ڕWlɉƍl
			p += OUT_FAR;								// 傫ω
		}
	}else if (LEVEL_AD < ad0_ave){						// ܂
		if(ad0_ave <= LEVEL_AD_H){						// ڕWlɗƍl
			p -= OUT_BAND;								// ۂ͉Ȃ
		}else if(nxt_ad0_ave <= LEVEL_AD_NH){			// ڕWlɖwǋ߂Âƍl
			p -= OUT_NEAR;								// ω
		}else if(nxt_ad0_ave <= LEVEL_AD_MH){			// ڕWlɑ啪߂Âƍl
			p -= OUT_MID;								// ω
		}else if(LEVEL_AD_MH < nxt_ad0_ave){			// ڕWlɉƍl
			p -= OUT_FAR;								// 傫ω
		}
	}

	if(p < PULSE_OUT_MIN){
		p = PULSE_OUT_MIN;
	}else if(PULSE_OUT_MAX < p){
		p = PULSE_OUT_MAX;
	}

	if((LEVEL_AD - 200) < nxt_ad0_ave){						// QOOO̎
		if(25 < sa){										// ωʂRT𒴂Ă鎞
			p = 200;
		}
	}

	pulse_out = p;

	if((LEVEL_LED_L <= ad0_ave)&&(ad0_ave <= LEVEL_LED_H)){	// kdc_͈͂ɗƍl
		dc_match=1;
	}else{
		dc_match=0;
	}

	bef1_ad0_ave = ad0_ave;
}
// QOOuۂ
void	stabilizer_200v(void)
{
	if(tim_10ms_ad == 0){
		tim_10ms_ad = 10;									// 100mS Ԋuł`^cf[^擾
		ad0_get_data();										// ρ@A/D l̎擾
		feed_back_pro();
		set_timer1_ontime();
		if(dc_match==1){
			led_on();										// LED ON
			dynamic_nixie_active(1);
		}else{
			led_off();										// LED OFF
		}
	}
}

// `FbNs
void	check(void)
{
	unsigned char	uc;
	unsigned char	old_run = 0;
	unsigned char	v200 = 0;
	unsigned char	kazu = 0;
	unsigned char	keta = 0;

	led_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_off();										// LED OFF

	get_sw();

	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	old_run = run;
	sei();											// 荞݉

	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	for(;;){
		uc = get_action_sw();									// XCb`Ԃ
		uc &= SW_MASK;											// XCb`ɂ
		if((uc == SW_OFF_SHORT) ||(uc == SW_OFF_LONG)){			// XCb`NbNꂽ
			bef1_ad0_ave = 0;
			output_data();										// f[^o͑삷
			kazu = 0;
			keta = 2;
		}

		if(tim_10ms_blink == 0){
			if(v200 != 0){
				tim_10ms_blink = 100;							// 1000mS Ԋu
				if(kazu == 10){
					disp_static_nixie_dot(keta);				// _
				}else{
					disp_static_nixie_number(keta, kazu);		// 
				}
				kazu++;
				if(10 < kazu){									// Oɖ߂
					kazu = 0;
					keta++;
					if(3 < keta){								// \߂
						keta = 2;
					}
				}
			}
		}

		if(tim_10ms_ad == 0){
			tim_10ms_ad = 10;									// 100mS Ԋuł`^cf[^擾
			ad0_get_data();										// ρ@A/D l̎擾
			if(run == 1){
				feed_back_pro();
	 			set_timer1_ontime();
				if(dc_match==1){
					led_on();									// LED ON
					v200=1;
				}else{
					led_off();									// LED OFF
				}
			}else{
				led_off();										// LED OFF
				v200=0;
			}
		}

		if(old_run != run){
			old_run = run;
			if(run == 1){
				pulse_on();
			}else{
				pulse_off();
				disp_static_nixie_number(2, 15);		// 
			}
		}

	}

}
// v̕\
// step : 0 -> 3 0=hour,month,year(H)  1=minute,day,year(L) 2=Number 0--9 fast scrol 3=Blank
// change: sec change now
// mode: disp mode
static	void	disp_clock(unsigned char step, unsigned char change, unsigned mode)
{

	if(step == 0){
		if(mode == HM){								// \̎
			if((gRTC_hou & 0xf0)==0){				// iʌO̎j
				disp_nixie_tow(0xf0 | gRTC_hou);	//  ̂ݕ\
			}else{
				disp_nixie_tow(gRTC_hou);			//  Q\
			}
		}else if(mode == MD){						// \̎
			if((gRTC_mon & 0xf0)==0){				// iʌO̎j
				disp_nixie_tow(0xf0 | gRTC_mon);	//  ̂ݕ\
			}else{
				disp_nixie_tow(gRTC_mon);			//  Q\
			}
		}else if(mode == YE){						// N\̎
			disp_nixie_tow(0x20);					// QO Q\
		}else{										// ̑i͖͂j
			disp_nixie_tow(0x20);					// QO Q\
		}
		disp_dynamic_nixie_dot(2,0);				// 㑤_Ȃ
		disp_dynamic_nixie_dot(3,0);				// _Ȃ
	}else if(step == 1){
		if(mode == HM){								// \̎
			if((gRTC_min & 0xf0)==0){				// iʌO̎j
				disp_nixie_tow(0xf0 | gRTC_min);	//  ̂ݕ\
			}else{
				disp_nixie_tow(gRTC_min);			//  Q\
			}
			disp_dynamic_nixie_dot(3,1);			// _
		}else if(mode == MD){						// \̎
			if((gRTC_day & 0xf0)==0){				// iʌO̎j
				disp_nixie_tow(0xf0 | gRTC_day);	//  ̂ݕ\
			}else{
				disp_nixie_tow(gRTC_day);			//  Q\
			}
			disp_dynamic_nixie_dot(2,1);			// 㑤_
		}else if(mode == YE){						// N\̎
			disp_nixie_tow(gRTC_year);				// N Q\
			disp_dynamic_nixie_dot(2,1);			// 㑤_
			disp_dynamic_nixie_dot(3,1);			// _
		}else{										// ̑i͖͂j
			disp_nixie_tow(gRTC_year);				// N Q\
			disp_dynamic_nixie_dot(2,1);			// 㑤_
			disp_dynamic_nixie_dot(3,1);			// _
		}
	}else if(step == 2){
		disp_nixie_tow((renzoku[num_count] << 4) | gyaku_renzoku[num_count]);	// \
		disp_dynamic_nixie_dot(2,0);				// 㑤_Ȃ
		disp_dynamic_nixie_dot(3,0);				// _Ȃ
		num_count++;
	}else if(step == 3){
		disp_nixie_tow(0xff);						// uN
		disp_dynamic_nixie_dot(2,0);				// 㑤_Ȃ
		disp_dynamic_nixie_dot(3,0);				// _Ȃ
	}else{
		disp_nixie_tow(0xff);						// uN
		disp_dynamic_nixie_dot(2,0);				// 㑤_Ȃ
		disp_dynamic_nixie_dot(3,0);				// _Ȃ
	}
}
//***************************
//  Main
//***************************
int	main(void)
{

	char			uc;
	unsigned char	disp_clock_step=3;
	unsigned char	disp_clock_mode=HM;
	unsigned char	old_rtc_1s_flg=0xff;

	PRR |= ( (1 << PRTWI) | (1 << PRSPI) | (1 << PRUSART0) | (1 << PRTIM0) | (1 << PRTIM1) | (1 << PRTIM2) | (1 << PRADC) );	// TWI, SPI, UART0, Timer0, Timer1, Timer2, ADC ~
	delay_ms(200);									// 200mS Delay


	init_nixe();									// Nixe\ 
	sw_init();										// XCb`֌W̏ݒ
	rtc_init();										// qsb̏ݒ
	led_init();										// kdc֌W̏ݒ
	timer1_init();									// Timer1 Initial
	timer2_init();									// Timer2 Initial
	ad0_init();										// A/D 5 Initial

//20160807 ~߂	if((PIND & SW_ON_BIT) == 0){					// XCb`f[^Ă
//20160807 ~߂		check();									// `FbNs
//20160807 ~߂	}

	sei();											// 荞݉

	bef1_ad0_ave = 0;
	pulse_out = PULSE_OUT_MAX;
	pulse_on();										// 200V Output Start
	tim_10ms_nixie = 100;

	while(1){
		uc = get_action_sw();									// XCb`Ԃ
		uc &= SW_MASK;											// XCb`ɂ
		if(uc == SW_OFF_LONG){									// ꂽ
			proc_no_key_timeup(1);								// L[͂L
			disp_clock_mode = SET;
			proc_set_rtc();										// v킹
			disp_clock_mode = HM;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
			disp_clock_step = 3;
		}else if(uc == SW_OFF_SHORT){							// Zꂽ
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HM:
				disp_clock_mode = MD;
				break;
			 case MD:
				disp_clock_mode = YE;
				break;
			 case YE:
				disp_clock_mode = HM;
				break;
			 default:
				disp_clock_mode = HM;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
			disp_clock_step = 3;
			tim_10ms_nixie = 0;
		}else{
			if(tim_10ms_nixie == 0){							// POO
				tim_10ms_nixie = 10;
				if(rtc_1s_flg != old_rtc_1s_flg){				// qsbĂ鎞̂Pboߗp
					old_rtc_1s_flg = rtc_1s_flg;
					rtc_read();									// RTC ǂݏo
					disp_clock(disp_clock_step, 1, disp_clock_mode);	// v̕\
					disp_clock_step++;
					if(3 < disp_clock_step){
						disp_clock_step = 0;
					}
					num_count=0;
				}else{
					disp_clock(disp_clock_step, 0, disp_clock_mode);	// v̕\
				}

				if (proc_no_key_timeup(0) == 0xff){				// ԃL[͂
					if(disp_clock_mode != HM){					// \Ŗ
						disp_clock_mode = HM;
						disp_clock_step = 3;
					}
				}
			}
		}
		stabilizer_200v();										// QOOuۂ
	}
}
